﻿// JRMC Gadget v2.4

var BROWSE_FILTER = "Image Files:*.jpg;*.png;*.gif::";
var SETTINGS_SIZING = "?width=100&height=100";
var gCurIndex = 0;
var gImageStrings      = new Array(
                            "Background Image",
                            "Default Thumbnail",
                            "Missing Thumbnail");
var gTempImageFiles = new Array("", "", "");

function LoadSettings()
{
    System.Gadget.onSettingsClosing = SettingsClosing;
    ShowGroup(0);
    
    // Load from settings file
    for( var i=0; i < gTempImageFiles.length; i++)
        gTempImageFiles[i] = System.Gadget.Settings.readString("img" + i);
    CHECKBORDER.checked = System.Gadget.Settings.read( "Border");
 //   CHECKDIVIDER.checked = System.Gadget.Settings.read( "Divider");
    PNTEXT.value = System.Gadget.Settings.readString( "PlayNowExp");
    MARGINSTEXT.value = System.Gadget.Settings.readString( "Margins");
    TAGSTEXT.value = System.Gadget.Settings.readString( "Tags");
    ZONETEXT.value = System.Gadget.Settings.readString( "Zone");
    COMMANDTEXT.value = System.Gadget.Settings.readString( "StartCommand");
    HEIGHTTEXT.value = System.Gadget.Settings.readString( "Height");
    TIMEDISPLAY.value = System.Gadget.Settings.readString( "TimeString");
    CHECKSHOWUI.checked = System.Gadget.Settings.read( "ShowUI");
    CHECKCONNECT.checked = System.Gadget.Settings.read( "AutoConnect");
    
    try
    {
        var tmp = parseInt( System.Gadget.Settings.readString( "ImageDisplay"));
        if( tmp < 0 || tmp > 5)
            tmp = 0;
        IMGCOMBO.selectedIndex = tmp;
    }
    catch( err)
    {
        IMGCOMBO.options.selectedindex = 0;
    }

    try 
    {
        var tmp = parseInt(System.Gadget.Settings.readString("Divider"));
        if (tmp < 0 || tmp > 2)
            tmp = 0;
        DIVIDERCOMBO.selectedIndex = tmp;
    }
    catch (err) {
        DIVIDERCOMBO.options.selectedindex = 0;
    }

    VTEXT.value = System.Gadget.Settings.read("Launcher");
    TEXTCOLOR.value = System.Gadget.Settings.read("TextColor");
    PROGCOLOR.value = System.Gadget.Settings.read("ProgColor");
    PBACKCOLOR.value = System.Gadget.Settings.read("ProgBackColor");
    ApplyColors();
    
    // Set image
    LoadSettingsImage();
}

function SettingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
        // Write to settings file
        for( var i=0; i < gTempImageFiles.length; i++)
            System.Gadget.Settings.writeString("img" + i, gTempImageFiles[i]);
        System.Gadget.Settings.write( "Border", CHECKBORDER.checked);
        System.Gadget.Settings.write( "Divider", DIVIDERCOMBO.selectedIndex);
        System.Gadget.Settings.writeString( "PlayNowExp", PNTEXT.value);
        System.Gadget.Settings.writeString( "Margins", MARGINSTEXT.value);
        System.Gadget.Settings.writeString( "Tags", TAGSTEXT.value);
        System.Gadget.Settings.writeString( "Zone", ZONETEXT.value);
        System.Gadget.Settings.writeString( "StartCommand", COMMANDTEXT.value);
        System.Gadget.Settings.writeString( "Height", HEIGHTTEXT.value);
        System.Gadget.Settings.writeString( "ImageDisplay", IMGCOMBO.selectedIndex);
        System.Gadget.Settings.writeString( "TimeString", TIMEDISPLAY.value);
        System.Gadget.Settings.write( "ShowUI", CHECKSHOWUI.checked);
        System.Gadget.Settings.write("AutoConnect", CHECKCONNECT.checked);
        System.Gadget.Settings.write("Launcher", VTEXT.value);
        System.Gadget.Settings.write("TextColor", TEXTCOLOR.value);
        System.Gadget.Settings.write("ProgColor", PROGCOLOR.value);
        System.Gadget.Settings.write("ProgBackColor", PBACKCOLOR.value);
    }
}

function LoadSettingsImage()
{
    IMAGETEXT.innerText = gImageStrings[gCurIndex];
    CURIMAGE.src = "gimage:///" + gTempImageFiles[gCurIndex] + SETTINGS_SIZING;
}

function PREVIMAGE_onclick() 
{
    if( gCurIndex == 0)
        gCurIndex = gTempImageFiles.length - 1;
    else
        gCurIndex--;
        
    LoadSettingsImage();
}

function NEXTIMAGE_onclick() 
{
    if( gCurIndex == gTempImageFiles.length - 1)
        gCurIndex = 0;
    else
        gCurIndex++;
        
    LoadSettingsImage();
}

function BROWSE_onclick() 
{
    try
    {
        var index = gTempImageFiles[gCurIndex].lastIndexOf( '\\');
        var newFile = System.Shell.chooseFile( true, BROWSE_FILTER, gTempImageFiles[gCurIndex].slice(0,index), gTempImageFiles[gCurIndex].slice(index+1));
        if( newFile != null)
        {
            gTempImageFiles[gCurIndex] = newFile.path;
            LoadSettingsImage();
         }
    }
    catch( err)
    {
        //IMAGETEXT.innerText = err.Description;
    }
}

function ShowGroup(group) {
    GENERALGROUP.style.display = (group == 0) ? "block" : "none";
    DISPLAYGROUP.style.display = (group == 1) ? "block" : "none";
    COLORGROUP.style.display = (group == 2) ? "block" : "none";
    ADVGROUP.style.display = (group == 3) ? "block" : "none"
}

function ApplyColors()
{
    DTCOLOR.style.backgroundColor = TEXTCOLOR.value;
    DIVCOLOR.style.backgroundColor = PROGCOLOR.value;
    PBCOLOR.style.backgroundColor = PBACKCOLOR.value;
}